--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE 'https://github.com/istio/istio' REPO source_repo: https://github.com/istio/istio title: sidecar-injector description: Kubernetes webhook for automatic Istio sidecar injection. generator: pkg-collateral-docs number_of_entries: 4 max_toc_level: 2 remove_toc_prefix: 'sidecar-injector ' ---

Kubernetes webhook for automatic Istio sidecar injection.

    sidecar-injector [flags]

Flags | Description
--- | ---
`--caCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/root-cert.pem`)
`--healthCheckFile <string>` | File that should be periodically updated if health checking is enabled (default ``)
`--healthCheckInterval <duration>` | Configure how frequently the health check file specified by --healthCheckFile should be updated (default `0s`)
`--injectConfig <string>` | File containing the Istio sidecar injection configuration and template (default `/etc/istio/inject/config`)
`--injectValues <string>` | File containing the Istio sidecar injection values, in yaml format (default `/etc/istio/inject/values`)
`--kubeconfig <string>` | Specifies path to kubeconfig file. This must be specified when not running inside a Kubernetes pod. (default ``)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac, validation] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac, validation] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac, validation] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfig <string>` | File containing the Istio mesh configuration (default `/etc/istio/config/mesh`)
`--monitoringPort <int>` | Webhook monitoring port (default `15014`)
`--port <int>` | Webhook port (default `9443`)
`--reconcileWebhookConfig` | Enable managing webhook configuration.
`--tlsCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/cert-chain.pem`)
`--tlsKeyFile <string>` | File containing the x509 private key matching --tlsCertFile. (default `/etc/istio/certs/key.pem`)
`--webhookConfigName <string>` | Name of the mutatingwebhookconfiguration resource in Kubernetes. (default `istio-sidecar-injector`)
`--webhookName <string>` | Name of the webhook entry in the webhook config. (default `sidecar-injector.istio.io`)

## sidecar-injector probe

Check the liveness or readiness of a locally-running server

    sidecar-injector probe [flags]

Flags | Description
--- | ---
`--caCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/root-cert.pem`)
`--healthCheckFile <string>` | File that should be periodically updated if health checking is enabled (default ``)
`--healthCheckInterval <duration>` | Configure how frequently the health check file specified by --healthCheckFile should be updated (default `0s`)
`--injectConfig <string>` | File containing the Istio sidecar injection configuration and template (default `/etc/istio/inject/config`)
`--injectValues <string>` | File containing the Istio sidecar injection values, in yaml format (default `/etc/istio/inject/values`)
`--interval <duration>` | Duration used for checking the target file's last modified time. (default `0s`)
`--kubeconfig <string>` | Specifies path to kubeconfig file. This must be specified when not running inside a Kubernetes pod. (default ``)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac, validation] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac, validation] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac, validation] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfig <string>` | File containing the Istio mesh configuration (default `/etc/istio/config/mesh`)
`--monitoringPort <int>` | Webhook monitoring port (default `15014`)
`--port <int>` | Webhook port (default `9443`)
`--probe-path <string>` | Path of the file for checking the availability. (default ``)
`--reconcileWebhookConfig` | Enable managing webhook configuration.
`--tlsCertFile <string>` | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/cert-chain.pem`)
`--tlsKeyFile <string>` | File containing the x509 private key matching --tlsCertFile. (default `/etc/istio/certs/key.pem`)
`--webhookConfigName <string>` | Name of the mutatingwebhookconfiguration resource in Kubernetes. (default `istio-sidecar-injector`)
`--webhookName <string>` | Name of the webhook entry in the webhook config. (default `sidecar-injector.istio.io`)

## sidecar-injector version

Prints out build version information

    sidecar-injector version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--caCertFile <string>` |  | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/root-cert.pem`)
`--healthCheckFile <string>` |  | File that should be periodically updated if health checking is enabled (default ``)
`--healthCheckInterval <duration>` |  | Configure how frequently the health check file specified by --healthCheckFile should be updated (default `0s`)
`--injectConfig <string>` |  | File containing the Istio sidecar injection configuration and template (default `/etc/istio/inject/config`)
`--injectValues <string>` |  | File containing the Istio sidecar injection values, in yaml format (default `/etc/istio/inject/values`)
`--kubeconfig <string>` |  | Specifies path to kubeconfig file. This must be specified when not running inside a Kubernetes pod. (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac, validation] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac, validation] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac, validation] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--meshConfig <string>` |  | File containing the Istio mesh configuration (default `/etc/istio/config/mesh`)
`--monitoringPort <int>` |  | Webhook monitoring port (default `15014`)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--port <int>` |  | Webhook port (default `9443`)
`--reconcileWebhookConfig` |  | Enable managing webhook configuration.
`--short` | `-s` | Use --short=false to generate full version information
`--tlsCertFile <string>` |  | File containing the x509 Certificate for HTTPS. (default `/etc/istio/certs/cert-chain.pem`)
`--tlsKeyFile <string>` |  | File containing the x509 private key matching --tlsCertFile. (default `/etc/istio/certs/key.pem`)
`--webhookConfigName <string>` |  | Name of the mutatingwebhookconfiguration resource in Kubernetes. (default `istio-sidecar-injector`)
`--webhookName <string>` |  | Name of the webhook entry in the webhook config. (default `sidecar-injector.istio.io`)

## Environment variables

These environment variables affect the behavior of the `sidecar-injector` command.

Variable Name | Type | Default Value | Description
--- | --- | --- | ---
`ISTIOD_ADDR` | String | `` | Service name of istiod. If empty the istiod listener, certs will be disabled.
`ISTIO_GPRC_MAXSTREAMS` | Integer | `100000` | Sets the maximum number of concurrent grpc streams.
`PILOT_BLOCK_HTTP_ON_443` | Boolean | `true` | If enabled, any HTTP services will be blocked on HTTPS port (443). If this is disabled, any HTTP service on port 443 could block all external traffic
`PILOT_CERT_DIR` | String | `` |
`PILOT_DEBOUNCE_AFTER` | Time Duration | `100ms` | The delay added to config/registry events for debouncing. This will delay the push by at least this internal. If no change is detected within this period, the push will happen, otherwise we'll keep delaying until things settle, up to a max of PILOT_DEBOUNCE_MAX.
`PILOT_DEBOUNCE_MAX` | Time Duration | `10s` | The maximum amount of time to wait for events while debouncing. If events keep showing up with no breaks for this time, we'll trigger a push.
`PILOT_DEBUG_ADSZ_CONFIG` | Boolean | `false` |
`PILOT_DISABLE_XDS_MARSHALING_TO_ANY` | Boolean | `false` |
`PILOT_DISTRIBUTION_HISTORY_RETENTION` | Time Duration | `1m0s` | If enabled, Pilot will keep track of old versions of distributed config for this duration.
`PILOT_ENABLE_CONFIG_DISTRIBUTION_TRACKING` | Boolean | `true` | If enabled, Pilot will assign meaningful nonces to each Envoy configuration message, and allow users to interrogate which envoy has which config from the debug interface.
`PILOT_ENABLE_CRD_VALIDATION` | Boolean | `false` | If enabled, pilot will validate CRDs while retrieving CRDs from kubernetes cache.Use this flag to enable validation of CRDs in Pilot, especially in deployments that do not have galley installed.
`PILOT_ENABLE_EDS_DEBOUNCE` | Boolean | `true` | If enabled, Pilot will include EDS pushes in the push debouncing, configured by PILOT_DEBOUNCE_AFTER and PILOT_DEBOUNCE_MAX. EDS pushes may be delayed, but there will be fewer pushes. By default this is enabled
`PILOT_ENABLE_FALLTHROUGH_ROUTE` | Boolean | `true` | EnableFallthroughRoute provides an option to add a final wildcard match for routes. When ALLOW_ANY traffic policy is used, a Passthrough cluster is used. When REGISTRY_ONLY traffic policy is used, a 502 error is returned.
`PILOT_ENABLE_HEADLESS_SERVICE_POD_LISTENERS` | Boolean | `true` | If enabled, for a headless service/stateful set in Kubernetes, pilot will generate an outbound listener for each pod in a headless service. This feature should be disabled if headless services have a large number of pods.
`PILOT_ENABLE_MYSQL_FILTER` | Boolean | `false` | EnableMysqlFilter enables injection of `envoy.filters.network.mysql_proxy` in the filter chain.
`PILOT_ENABLE_PROTOCOL_SNIFFING_FOR_INBOUND` | Boolean | `true` | If enabled, protocol sniffing will be used for inbound listeners whose port protocol is not specified or unsupported
`PILOT_ENABLE_PROTOCOL_SNIFFING_FOR_OUTBOUND` | Boolean | `true` | If enabled, protocol sniffing will be used for outbound listeners whose port protocol is not specified or unsupported
`PILOT_ENABLE_REDIS_FILTER` | Boolean | `false` | EnableRedisFilter enables injection of `envoy.filters.network.redis_proxy` in the filter chain.
`PILOT_ENABLE_UNSAFE_REGEX` | Boolean | `false` | If enabled, pilot will generate Envoy configuration that does not use safe_regex but the older, deprecated regex field. This should only be enabled to support legacy deployments that have not yet been migrated to the new safe regular expressions.
`PILOT_HTTP10` | Boolean | `false` | Enables the use of HTTP 1.0 in the outbound HTTP listeners, to support legacy applications.
`PILOT_INBOUND_PROTOCOL_DETECTION_TIMEOUT` | Time Duration | `1s` | Protocol detection timeout for inbound listener
`PILOT_INITIAL_FETCH_TIMEOUT` | Time Duration | `0s` | Specifies the initial_fetch_timeout for config. If this time is reached without a response to the config requested by Envoy, the Envoy will move on with the init phase. This prevents envoy from getting stuck waiting on config during startup.
`PILOT_PUSH_THROTTLE` | Integer | `100` | Limits the number of concurrent pushes allowed. On larger machines this can be increased for faster pushes
`PILOT_RESPECT_DNS_TTL` | Boolean | `true` | If enabled, DNS based clusters will respect the TTL of the DNS, rather than polling at a fixed rate. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_RESTRICT_POD_UP_TRAFFIC_LOOP` | Boolean | `true` | If enabled, this will block inbound traffic from matching outbound listeners, which could result in an infinite loop of traffic. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_SCOPE_GATEWAY_TO_NAMESPACE` | Boolean | `false` | If enabled, a gateway workload can only select gateway resources in the same namespace. Gateways with same selectors in different namespaces will not be applicable.
`PILOT_SCOPE_PUSHES` | Boolean | `true` | If enabled, pilot will attempt to limit unnecessary pushes by determining what proxies a config or endpoint update will impact.
`PILOT_SIDECAR_USE_REMOTE_ADDRESS` | Boolean | `false` | UseRemoteAddress sets useRemoteAddress to true for side car outbound listeners.
`PILOT_SKIP_VALIDATE_TRUST_DOMAIN` | Boolean | `false` | Skip validating the peer is from the same trust domain when mTLS is enabled in authentication policy
`PILOT_TRACE_SAMPLING` | Floating-Point | `100` | Sets the mesh-wide trace sampling percentage. Should be 0.0 - 100.0. Precision to 0.01. Default is 100, not recommended for production use.
`TERMINATION_DRAIN_DURATION_SECONDS` | Integer | `5` | The amount of time allowed for connections to complete on pilot-agent shutdown. On receiving SIGTERM or SIGINT, pilot-agent tells the active Envoy to start draining, preventing any new connections and allowing existing connections to complete. It then sleeps for the TerminationDrainDuration and then kills any remaining active Envoy processes.
`USE_ISTIO_JWT_FILTER` | Boolean | `false` | Use the Istio JWT filter for JWT token verification.

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`endpoint_no_pod` | `LastValue` | Endpoints without an associated pod.
`istio_build` | `LastValue` | Istio component build info
`pilot_conflict_inbound_listener` | `LastValue` | Number of conflicting inbound listeners.
`pilot_conflict_outbound_listener_http_over_current_tcp` | `LastValue` | Number of conflicting wildcard http listeners with current wildcard tcp listener.
`pilot_conflict_outbound_listener_http_over_https` | `LastValue` | Number of conflicting HTTP listeners with well known HTTPS ports
`pilot_conflict_outbound_listener_tcp_over_current_http` | `LastValue` | Number of conflicting wildcard tcp listeners with current wildcard http listener.
`pilot_conflict_outbound_listener_tcp_over_current_tcp` | `LastValue` | Number of conflicting tcp listeners with current tcp listener.
`pilot_destrule_subsets` | `LastValue` | Duplicate subsets across destination rules for same host
`pilot_duplicate_envoy_clusters` | `LastValue` | Duplicate envoy clusters caused by service entries with same hostname
`pilot_eds_no_instances` | `LastValue` | Number of clusters without instances.
`pilot_endpoint_not_ready` | `LastValue` | Endpoint found in unready state.
`pilot_jwks_resolver_network_fetch_fail_total` | `Sum` | Total number of failed network fetch by pilot jwks resolver
`pilot_jwks_resolver_network_fetch_success_total` | `Sum` | Total number of successfully network fetch by pilot jwks resolver
`pilot_no_ip` | `LastValue` | Pods not found in the endpoint table, possibly invalid.
`pilot_total_rejected_configs` | `Sum` | Total number of configs that Pilot had to reject or ignore.
`pilot_virt_services` | `LastValue` | Total virtual services known to pilot.
`pilot_vservice_dup_domain` | `LastValue` | Virtual services with dup domains.
`sidecar_injection_failure_total` | `Sum` | Total number of failed Side car injection requests.
`sidecar_injection_requests_total` | `Sum` | Total number of Side car injection requests.
`sidecar_injection_skip_total` | `Sum` | Total number of skipped injection requests.
`sidecar_injection_success_total` | `Sum` | Total number of successful Side car injection requests.